{
  Solutions to the Advent Of Code.
  Copyright (C) 2023  Stefan Müller

  This program is free software: you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free Software
  Foundation, either version 3 of the License, or (at your option) any later
  version.

  This program is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

  You should have received a copy of the GNU General Public License along with
  this program.  If not, see <http://www.gnu.org/licenses/>.
}

unit UClumsyCrucibleTestCases;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, fpcunit, testregistry, USolver, UBaseTestCases, UClumsyCrucible;

type

  { TClumsyCrucibleFullDataTestCase }

  TClumsyCrucibleFullDataTestCase = class(TEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

  { TClumsyCrucibleExampleTestCase }

  TClumsyCrucibleExampleTestCase = class(TExampleEngineBaseTest)
  protected
    function CreateSolver: ISolver; override;
  published
    procedure TestPart1;
    procedure TestPart2;
  end;

implementation

{ TClumsyCrucibleFullDataTestCase }

function TClumsyCrucibleFullDataTestCase.CreateSolver: ISolver;
begin
  Result := TClumsyCrucible.Create;
end;

procedure TClumsyCrucibleFullDataTestCase.TestPart1;
begin
  AssertEquals(-1, FSolver.GetResultPart1);
end;

procedure TClumsyCrucibleFullDataTestCase.TestPart2;
begin
  AssertEquals(-1, FSolver.GetResultPart2);
end;

{ TClumsyCrucibleExampleTestCase }

function TClumsyCrucibleExampleTestCase.CreateSolver: ISolver;
begin
  Result := TClumsyCrucible.Create;
end;

procedure TClumsyCrucibleExampleTestCase.TestPart1;
begin
  AssertEquals(102, FSolver.GetResultPart1);
end;

procedure TClumsyCrucibleExampleTestCase.TestPart2;
begin
  AssertEquals(-1, FSolver.GetResultPart2);
end;

initialization

  //RegisterTest(TClumsyCrucibleFullDataTestCase);
  //RegisterTest(TClumsyCrucibleExampleTestCase);
end.

